(use test)

(test-group "Stack ops"
  (test '(stack) (begin-stack 1 stk-drop))
  (test '(stack) (begin-stack 1 2 stk-2drop))
  (test '(stack) (begin-stack 1 2 3 stk-3drop))
  (test-error (begin-stack stk-drop))
  (test '(stack y) (begin-stack 'x 'y stk-nip))
  (test '(stack z) (begin-stack 'x 'y 'z stk-2nip))
  (test '(stack x x) (begin-stack 'x stk-dup))
  (test '(stack x y x y) (begin-stack 'y 'x stk-2dup))
  (test '(stack x y z x y z) (begin-stack 'z 'y 'x stk-3dup))
  (test '(stack y x x) (begin-stack 'x 'y stk-dupd))
  (test '(stack x y x) (begin-stack 'x 'y stk-over))
  (test '(stack x z y x) (begin-stack 'x 'y 'z stk-pick))
  (test '(stack y x y) (begin-stack 'x 'y stk-tuck))
  (test '(stack x y) (begin-stack 'x 'y stk-swap))
  (test '(stack z x y) (begin-stack 'x 'y 'z stk-swapd))
  (test '(stack x z y) (begin-stack 'x 'y 'z stk-rot))
  (test '(stack y x z) (begin-stack 'x 'y 'z stk--rot))
  (test '(stack x t z y) (begin-stack 'x 'y 'z 't stk-roll))
  (test '(stack z y x t) (begin-stack 'x 'y 'z 't stk--roll)))